=begin
#Hydrogen Proton API

#Financial engineering module of Hydrogen Atom

OpenAPI spec version: 1.9.0
Contact: info@hydrogenplatform.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'uri'

module ProtonApi
  class UtilApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Decision Tree Result
    # Traverse a decision tree and find the resulting leaf node
    # @param decision_tree_result_request Request payload for Decision Tree Result
    # @param [Hash] opts the optional parameters
    # @return [Hash<String, Object>]
    def decision_tree_result(decision_tree_result_request, opts = {})
      data, _status_code, _headers = decision_tree_result_with_http_info(decision_tree_result_request, opts)
      data
    end

    # Decision Tree Result
    # Traverse a decision tree and find the resulting leaf node
    # @param decision_tree_result_request Request payload for Decision Tree Result
    # @param [Hash] opts the optional parameters
    # @return [Array<(Hash<String, Object>, Fixnum, Hash)>] Hash<String, Object> data, response status code and response headers
    def decision_tree_result_with_http_info(decision_tree_result_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UtilApi.decision_tree_result ...'
      end
      # verify the required parameter 'decision_tree_result_request' is set
      if @api_client.config.client_side_validation && decision_tree_result_request.nil?
        fail ArgumentError, "Missing the required parameter 'decision_tree_result_request' when calling UtilApi.decision_tree_result"
      end
      # resource path
      local_var_path = '/decision_tree_result'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(decision_tree_result_request)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Hash<String, Object>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UtilApi#decision_tree_result\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Order Rebalance
    # Create orders to rebalance client accounts or portfolios
    # @param order_rebalance_request Request payload for Order Rebalance
    # @param [Hash] opts the optional parameters
    # @return [Hash<String, Object>]
    def order_rebalance(order_rebalance_request, opts = {})
      data, _status_code, _headers = order_rebalance_with_http_info(order_rebalance_request, opts)
      data
    end

    # Order Rebalance
    # Create orders to rebalance client accounts or portfolios
    # @param order_rebalance_request Request payload for Order Rebalance
    # @param [Hash] opts the optional parameters
    # @return [Array<(Hash<String, Object>, Fixnum, Hash)>] Hash<String, Object> data, response status code and response headers
    def order_rebalance_with_http_info(order_rebalance_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UtilApi.order_rebalance ...'
      end
      # verify the required parameter 'order_rebalance_request' is set
      if @api_client.config.client_side_validation && order_rebalance_request.nil?
        fail ArgumentError, "Missing the required parameter 'order_rebalance_request' when calling UtilApi.order_rebalance"
      end
      # resource path
      local_var_path = '/order_rebalance'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(order_rebalance_request)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Hash<String, Object>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UtilApi#order_rebalance\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Performance Calculator
    # Calculate performance/risk metrics for a Nucleus entity
    # @param performance_calculator_request Request payload for Performance Calculator
    # @param [Hash] opts the optional parameters
    # @return [Hash<String, Object>]
    def performance_calculator(performance_calculator_request, opts = {})
      data, _status_code, _headers = performance_calculator_with_http_info(performance_calculator_request, opts)
      data
    end

    # Performance Calculator
    # Calculate performance/risk metrics for a Nucleus entity
    # @param performance_calculator_request Request payload for Performance Calculator
    # @param [Hash] opts the optional parameters
    # @return [Array<(Hash<String, Object>, Fixnum, Hash)>] Hash<String, Object> data, response status code and response headers
    def performance_calculator_with_http_info(performance_calculator_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UtilApi.performance_calculator ...'
      end
      # verify the required parameter 'performance_calculator_request' is set
      if @api_client.config.client_side_validation && performance_calculator_request.nil?
        fail ArgumentError, "Missing the required parameter 'performance_calculator_request' when calling UtilApi.performance_calculator"
      end
      # resource path
      local_var_path = '/performance_calculator'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(performance_calculator_request)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Hash<String, Object>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UtilApi#performance_calculator\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
