=begin
#Hydrogen Proton API

#Financial engineering module of Hydrogen Atom

OpenAPI spec version: 1.9.0
Contact: info@hydrogenplatform.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module ProtonApi
  class DimensionalRiskScoreRequest
    attr_accessor :questionnaire_id

    attr_accessor :client_id

    attr_accessor :post_score

    attr_accessor :dims

    attr_accessor :answer_weights

    attr_accessor :max_answers

    attr_accessor :dim_weights

    attr_accessor :answers

    attr_accessor :answer_dims

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'questionnaire_id' => :'questionnaire_id',
        :'client_id' => :'client_id',
        :'post_score' => :'post_score',
        :'dims' => :'dims',
        :'answer_weights' => :'answer_weights',
        :'max_answers' => :'max_answers',
        :'dim_weights' => :'dim_weights',
        :'answers' => :'answers',
        :'answer_dims' => :'answer_dims'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'questionnaire_id' => :'String',
        :'client_id' => :'String',
        :'post_score' => :'BOOLEAN',
        :'dims' => :'Array<String>',
        :'answer_weights' => :'Array<Float>',
        :'max_answers' => :'Array<Float>',
        :'dim_weights' => :'Array<Float>',
        :'answers' => :'Array<Float>',
        :'answer_dims' => :'Array<Array<String>>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'questionnaire_id')
        self.questionnaire_id = attributes[:'questionnaire_id']
      end

      if attributes.has_key?(:'client_id')
        self.client_id = attributes[:'client_id']
      end

      if attributes.has_key?(:'post_score')
        self.post_score = attributes[:'post_score']
      else
        self.post_score = false
      end

      if attributes.has_key?(:'dims')
        if (value = attributes[:'dims']).is_a?(Array)
          self.dims = value
        end
      end

      if attributes.has_key?(:'answer_weights')
        if (value = attributes[:'answer_weights']).is_a?(Array)
          self.answer_weights = value
        end
      end

      if attributes.has_key?(:'max_answers')
        if (value = attributes[:'max_answers']).is_a?(Array)
          self.max_answers = value
        end
      end

      if attributes.has_key?(:'dim_weights')
        if (value = attributes[:'dim_weights']).is_a?(Array)
          self.dim_weights = value
        end
      end

      if attributes.has_key?(:'answers')
        if (value = attributes[:'answers']).is_a?(Array)
          self.answers = value
        end
      end

      if attributes.has_key?(:'answer_dims')
        if (value = attributes[:'answer_dims']).is_a?(Array)
          self.answer_dims = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @dims.nil?
        invalid_properties.push('invalid value for "dims", dims cannot be nil.')
      end

      if @max_answers.nil?
        invalid_properties.push('invalid value for "max_answers", max_answers cannot be nil.')
      end

      if @answer_dims.nil?
        invalid_properties.push('invalid value for "answer_dims", answer_dims cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @dims.nil?
      return false if @max_answers.nil?
      return false if @answer_dims.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          questionnaire_id == o.questionnaire_id &&
          client_id == o.client_id &&
          post_score == o.post_score &&
          dims == o.dims &&
          answer_weights == o.answer_weights &&
          max_answers == o.max_answers &&
          dim_weights == o.dim_weights &&
          answers == o.answers &&
          answer_dims == o.answer_dims
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [questionnaire_id, client_id, post_score, dims, answer_weights, max_answers, dim_weights, answers, answer_dims].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
# Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        value
      when :Date
        value
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = ProtonApi.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end
# Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end
# Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
