=begin
#Hydrogen Proton API

#Financial engineering module of Hydrogen Atom

OpenAPI spec version: 1.9.0
Contact: info@hydrogenplatform.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module ProtonApi
  class GuaranteedRateBenefit
    attr_accessor :max_rate

    attr_accessor :end_period

    attr_accessor :min_rate

    attr_accessor :start_period

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'max_rate' => :'max_rate',
        :'end_period' => :'end_period',
        :'min_rate' => :'min_rate',
        :'start_period' => :'start_period'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'max_rate' => :'Float',
        :'end_period' => :'Integer',
        :'min_rate' => :'Float',
        :'start_period' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'max_rate')
        self.max_rate = attributes[:'max_rate']
      end

      if attributes.has_key?(:'end_period')
        self.end_period = attributes[:'end_period']
      end

      if attributes.has_key?(:'min_rate')
        self.min_rate = attributes[:'min_rate']
      else
        self.min_rate = 0.0
      end

      if attributes.has_key?(:'start_period')
        self.start_period = attributes[:'start_period']
      else
        self.start_period = 1
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@max_rate.nil? && @max_rate < -1
        invalid_properties.push('invalid value for "max_rate", must be greater than or equal to -1.')
      end

      if !@end_period.nil? && @end_period < 1
        invalid_properties.push('invalid value for "end_period", must be greater than or equal to 1.')
      end

      if !@min_rate.nil? && @min_rate < -1
        invalid_properties.push('invalid value for "min_rate", must be greater than or equal to -1.')
      end

      if !@start_period.nil? && @start_period < 1
        invalid_properties.push('invalid value for "start_period", must be greater than or equal to 1.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@max_rate.nil? && @max_rate < -1
      return false if !@end_period.nil? && @end_period < 1
      return false if !@min_rate.nil? && @min_rate < -1
      return false if !@start_period.nil? && @start_period < 1
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] max_rate Value to be assigned
    def max_rate=(max_rate)
      if !max_rate.nil? && max_rate < -1
        fail ArgumentError, 'invalid value for "max_rate", must be greater than or equal to -1.'
      end

      @max_rate = max_rate
    end

    # Custom attribute writer method with validation
    # @param [Object] end_period Value to be assigned
    def end_period=(end_period)
      if !end_period.nil? && end_period < 1
        fail ArgumentError, 'invalid value for "end_period", must be greater than or equal to 1.'
      end

      @end_period = end_period
    end

    # Custom attribute writer method with validation
    # @param [Object] min_rate Value to be assigned
    def min_rate=(min_rate)
      if !min_rate.nil? && min_rate < -1
        fail ArgumentError, 'invalid value for "min_rate", must be greater than or equal to -1.'
      end

      @min_rate = min_rate
    end

    # Custom attribute writer method with validation
    # @param [Object] start_period Value to be assigned
    def start_period=(start_period)
      if !start_period.nil? && start_period < 1
        fail ArgumentError, 'invalid value for "start_period", must be greater than or equal to 1.'
      end

      @start_period = start_period
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          max_rate == o.max_rate &&
          end_period == o.end_period &&
          min_rate == o.min_rate &&
          start_period == o.start_period
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [max_rate, end_period, min_rate, start_period].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
# Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        value
      when :Date
        value
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = ProtonApi.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end
# Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end
# Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
