=begin
#Hydrogen Proton API

#Financial engineering module of Hydrogen Atom

OpenAPI spec version: 1.9.0
Contact: info@hydrogenplatform.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module ProtonApi
  class MvoRequest
    attr_accessor :tickers

    attr_accessor :w_config

    attr_accessor :min_assets

    attr_accessor :end_date

    attr_accessor :market_data_source

    attr_accessor :w_asset_config

    attr_accessor :start_date

    attr_accessor :tgt_type

    attr_accessor :use_proxy_data

    attr_accessor :tgt_val

    attr_accessor :sec_types

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'tickers' => :'tickers',
        :'w_config' => :'w_config',
        :'min_assets' => :'min_assets',
        :'end_date' => :'end_date',
        :'market_data_source' => :'market_data_source',
        :'w_asset_config' => :'w_asset_config',
        :'start_date' => :'start_date',
        :'tgt_type' => :'tgt_type',
        :'use_proxy_data' => :'use_proxy_data',
        :'tgt_val' => :'tgt_val',
        :'sec_types' => :'sec_types'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'tickers' => :'Array<String>',
        :'w_config' => :'WConfig',
        :'min_assets' => :'Integer',
        :'end_date' => :'Date',
        :'market_data_source' => :'String',
        :'w_asset_config' => :'Object',
        :'start_date' => :'Date',
        :'tgt_type' => :'String',
        :'use_proxy_data' => :'BOOLEAN',
        :'tgt_val' => :'Float',
        :'sec_types' => :'Array<String>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'tickers')
        if (value = attributes[:'tickers']).is_a?(Array)
          self.tickers = value
        end
      end

      if attributes.has_key?(:'w_config')
        self.w_config = attributes[:'w_config']
      end

      if attributes.has_key?(:'min_assets')
        self.min_assets = attributes[:'min_assets']
      end

      if attributes.has_key?(:'end_date')
        self.end_date = attributes[:'end_date']
      end

      if attributes.has_key?(:'market_data_source')
        self.market_data_source = attributes[:'market_data_source']
      else
        self.market_data_source = 'nucleus'
      end

      if attributes.has_key?(:'w_asset_config')
        self.w_asset_config = attributes[:'w_asset_config']
      end

      if attributes.has_key?(:'start_date')
        self.start_date = attributes[:'start_date']
      end

      if attributes.has_key?(:'tgt_type')
        self.tgt_type = attributes[:'tgt_type']
      end

      if attributes.has_key?(:'use_proxy_data')
        self.use_proxy_data = attributes[:'use_proxy_data']
      else
        self.use_proxy_data = false
      end

      if attributes.has_key?(:'tgt_val')
        self.tgt_val = attributes[:'tgt_val']
      else
        self.tgt_val = 0.0
      end

      if attributes.has_key?(:'sec_types')
        if (value = attributes[:'sec_types']).is_a?(Array)
          self.sec_types = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @tickers.nil?
        invalid_properties.push('invalid value for "tickers", tickers cannot be nil.')
      end

      if @w_config.nil?
        invalid_properties.push('invalid value for "w_config", w_config cannot be nil.')
      end

      if @min_assets.nil?
        invalid_properties.push('invalid value for "min_assets", min_assets cannot be nil.')
      end

      if @min_assets < 1
        invalid_properties.push('invalid value for "min_assets", must be greater than or equal to 1.')
      end

      if @sec_types.nil?
        invalid_properties.push('invalid value for "sec_types", sec_types cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @tickers.nil?
      return false if @w_config.nil?
      return false if @min_assets.nil?
      return false if @min_assets < 1
      market_data_source_validator = EnumAttributeValidator.new('String', ['nucleus', 'integration'])
      return false unless market_data_source_validator.valid?(@market_data_source)
      tgt_type_validator = EnumAttributeValidator.new('String', ['risk', 'return'])
      return false unless tgt_type_validator.valid?(@tgt_type)
      return false if @sec_types.nil?
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] min_assets Value to be assigned
    def min_assets=(min_assets)
      if min_assets.nil?
        fail ArgumentError, 'min_assets cannot be nil'
      end

      if min_assets < 1
        fail ArgumentError, 'invalid value for "min_assets", must be greater than or equal to 1.'
      end

      @min_assets = min_assets
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] market_data_source Object to be assigned
    def market_data_source=(market_data_source)
      validator = EnumAttributeValidator.new('String', ['nucleus', 'integration'])
      unless validator.valid?(market_data_source)
        fail ArgumentError, 'invalid value for "market_data_source", must be one of #{validator.allowable_values}.'
      end
      @market_data_source = market_data_source
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] tgt_type Object to be assigned
    def tgt_type=(tgt_type)
      validator = EnumAttributeValidator.new('String', ['risk', 'return'])
      unless validator.valid?(tgt_type)
        fail ArgumentError, 'invalid value for "tgt_type", must be one of #{validator.allowable_values}.'
      end
      @tgt_type = tgt_type
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          tickers == o.tickers &&
          w_config == o.w_config &&
          min_assets == o.min_assets &&
          end_date == o.end_date &&
          market_data_source == o.market_data_source &&
          w_asset_config == o.w_asset_config &&
          start_date == o.start_date &&
          tgt_type == o.tgt_type &&
          use_proxy_data == o.use_proxy_data &&
          tgt_val == o.tgt_val &&
          sec_types == o.sec_types
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [tickers, w_config, min_assets, end_date, market_data_source, w_asset_config, start_date, tgt_type, use_proxy_data, tgt_val, sec_types].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
# Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        value
      when :Date
        value
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = ProtonApi.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end
# Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end
# Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
