=begin
#Hydrogen Proton API

#Financial engineering module of Hydrogen Atom

OpenAPI spec version: 1.9.0
Contact: info@hydrogenplatform.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module ProtonApi
  class OrderRebalanceRequest
    attr_accessor :non_fractional

    attr_accessor :order_scope

    attr_accessor :buy_threshold

    attr_accessor :commit_orders

    attr_accessor :account_id

    attr_accessor :port_threshold

    attr_accessor :use_cash_available

    attr_accessor :use_strategic

    attr_accessor :sell_transaction_code_id

    attr_accessor :buy_transaction_code_id

    attr_accessor :cash_portfolio_id

    attr_accessor :restrictions_on

    attr_accessor :sell_threshold

    attr_accessor :portfolio_id

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'non_fractional' => :'non_fractional',
        :'order_scope' => :'order_scope',
        :'buy_threshold' => :'buy_threshold',
        :'commit_orders' => :'commit_orders',
        :'account_id' => :'account_id',
        :'port_threshold' => :'port_threshold',
        :'use_cash_available' => :'use_cash_available',
        :'use_strategic' => :'use_strategic',
        :'sell_transaction_code_id' => :'sell_transaction_code_id',
        :'buy_transaction_code_id' => :'buy_transaction_code_id',
        :'cash_portfolio_id' => :'cash_portfolio_id',
        :'restrictions_on' => :'restrictions_on',
        :'sell_threshold' => :'sell_threshold',
        :'portfolio_id' => :'portfolio_id'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'non_fractional' => :'BOOLEAN',
        :'order_scope' => :'String',
        :'buy_threshold' => :'Float',
        :'commit_orders' => :'BOOLEAN',
        :'account_id' => :'String',
        :'port_threshold' => :'Float',
        :'use_cash_available' => :'BOOLEAN',
        :'use_strategic' => :'BOOLEAN',
        :'sell_transaction_code_id' => :'String',
        :'buy_transaction_code_id' => :'String',
        :'cash_portfolio_id' => :'String',
        :'restrictions_on' => :'BOOLEAN',
        :'sell_threshold' => :'Float',
        :'portfolio_id' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'non_fractional')
        self.non_fractional = attributes[:'non_fractional']
      else
        self.non_fractional = false
      end

      if attributes.has_key?(:'order_scope')
        self.order_scope = attributes[:'order_scope']
      end

      if attributes.has_key?(:'buy_threshold')
        self.buy_threshold = attributes[:'buy_threshold']
      else
        self.buy_threshold = 0.0
      end

      if attributes.has_key?(:'commit_orders')
        self.commit_orders = attributes[:'commit_orders']
      else
        self.commit_orders = true
      end

      if attributes.has_key?(:'account_id')
        self.account_id = attributes[:'account_id']
      end

      if attributes.has_key?(:'port_threshold')
        self.port_threshold = attributes[:'port_threshold']
      else
        self.port_threshold = 0.0
      end

      if attributes.has_key?(:'use_cash_available')
        self.use_cash_available = attributes[:'use_cash_available']
      else
        self.use_cash_available = false
      end

      if attributes.has_key?(:'use_strategic')
        self.use_strategic = attributes[:'use_strategic']
      else
        self.use_strategic = false
      end

      if attributes.has_key?(:'sell_transaction_code_id')
        self.sell_transaction_code_id = attributes[:'sell_transaction_code_id']
      end

      if attributes.has_key?(:'buy_transaction_code_id')
        self.buy_transaction_code_id = attributes[:'buy_transaction_code_id']
      end

      if attributes.has_key?(:'cash_portfolio_id')
        self.cash_portfolio_id = attributes[:'cash_portfolio_id']
      end

      if attributes.has_key?(:'restrictions_on')
        self.restrictions_on = attributes[:'restrictions_on']
      else
        self.restrictions_on = false
      end

      if attributes.has_key?(:'sell_threshold')
        self.sell_threshold = attributes[:'sell_threshold']
      else
        self.sell_threshold = 0.0
      end

      if attributes.has_key?(:'portfolio_id')
        self.portfolio_id = attributes[:'portfolio_id']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @order_scope.nil?
        invalid_properties.push('invalid value for "order_scope", order_scope cannot be nil.')
      end

      if !@buy_threshold.nil? && @buy_threshold < 0
        invalid_properties.push('invalid value for "buy_threshold", must be greater than or equal to 0.')
      end

      if !@port_threshold.nil? && @port_threshold < 0
        invalid_properties.push('invalid value for "port_threshold", must be greater than or equal to 0.')
      end

      if !@sell_threshold.nil? && @sell_threshold < 1
        invalid_properties.push('invalid value for "sell_threshold", must be greater than or equal to 1.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @order_scope.nil?
      order_scope_validator = EnumAttributeValidator.new('String', ['all', 'buy_only', 'sell_only'])
      return false unless order_scope_validator.valid?(@order_scope)
      return false if !@buy_threshold.nil? && @buy_threshold < 0
      return false if !@port_threshold.nil? && @port_threshold < 0
      return false if !@sell_threshold.nil? && @sell_threshold < 1
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] order_scope Object to be assigned
    def order_scope=(order_scope)
      validator = EnumAttributeValidator.new('String', ['all', 'buy_only', 'sell_only'])
      unless validator.valid?(order_scope)
        fail ArgumentError, 'invalid value for "order_scope", must be one of #{validator.allowable_values}.'
      end
      @order_scope = order_scope
    end

    # Custom attribute writer method with validation
    # @param [Object] buy_threshold Value to be assigned
    def buy_threshold=(buy_threshold)
      if !buy_threshold.nil? && buy_threshold < 0
        fail ArgumentError, 'invalid value for "buy_threshold", must be greater than or equal to 0.'
      end

      @buy_threshold = buy_threshold
    end

    # Custom attribute writer method with validation
    # @param [Object] port_threshold Value to be assigned
    def port_threshold=(port_threshold)
      if !port_threshold.nil? && port_threshold < 0
        fail ArgumentError, 'invalid value for "port_threshold", must be greater than or equal to 0.'
      end

      @port_threshold = port_threshold
    end

    # Custom attribute writer method with validation
    # @param [Object] sell_threshold Value to be assigned
    def sell_threshold=(sell_threshold)
      if !sell_threshold.nil? && sell_threshold < 1
        fail ArgumentError, 'invalid value for "sell_threshold", must be greater than or equal to 1.'
      end

      @sell_threshold = sell_threshold
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          non_fractional == o.non_fractional &&
          order_scope == o.order_scope &&
          buy_threshold == o.buy_threshold &&
          commit_orders == o.commit_orders &&
          account_id == o.account_id &&
          port_threshold == o.port_threshold &&
          use_cash_available == o.use_cash_available &&
          use_strategic == o.use_strategic &&
          sell_transaction_code_id == o.sell_transaction_code_id &&
          buy_transaction_code_id == o.buy_transaction_code_id &&
          cash_portfolio_id == o.cash_portfolio_id &&
          restrictions_on == o.restrictions_on &&
          sell_threshold == o.sell_threshold &&
          portfolio_id == o.portfolio_id
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [non_fractional, order_scope, buy_threshold, commit_orders, account_id, port_threshold, use_cash_available, use_strategic, sell_transaction_code_id, buy_transaction_code_id, cash_portfolio_id, restrictions_on, sell_threshold, portfolio_id].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
# Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        value
      when :Date
        value
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = ProtonApi.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end
# Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end
# Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
